// start of selfreplicating code

#include <iostream>
#include <fstream>
#include <vector>
#include <string>
class selfrep
{

   static std::string MARKER;

   template<class T> void PRINT1(T x)
   {
      for(typename T::iterator it=x.begin(); it != x.end(); ++it)
      {
	 std::cout << *it << std::endl;
      }

   }

   template <class T> void PRINT2(const std::string& name, T x)
   {
      for(typename T::iterator it=x.begin(); it != x.end(); ++it)
	 std::cout << name << ".push_back(" << stringify(*it) << ");" << std::endl;
   }

   std::string stringify(const std::string& s)
   {
      std::string r;
      r = '"';
      for (unsigned int i = 0; i < s.size(); i++)
      {
	 char c = s[i];
	 switch(c)
	 {
	    case('"'):
	    case('\\'):
	       r += '\\';
	 }
	 r += c;
      }
      r += '"';
      return r;
   }

   template <class T> void printselfrepprog(T A,T B,int mode)
   {
      PRINT1(A);
      if (mode == 0)
      {
	 PRINT2("A",A);
	 PRINT2("B",B);
      }
      PRINT1(B);
   }

   public:
   selfrep()
   { }

   void selfreplicate(int mode)
   {
      std::vector<std::string> A;
      std::vector<std::string> B;
      // This is MARKER 

      printselfrepprog(A,B,mode);
   }

   void makeselfrep(const std::string& f)
   {
      std::ifstream infile(f.c_str());
      if (infile.fail())
      {
	 std::cout << "No such file: '"<<f<<"'"<<std::endl;
	 return;
      }
      std::string line;
      std::vector<std::string> A;
      std::vector<std::string> B;
      while (getline(infile,line))
      {
	 A.push_back(line);
	 if (line.find(this->MARKER)!=std::string::npos)
	    break;
      }
      while (getline(infile,line))
	 B.push_back(line);

      printselfrepprog(A,B,0);
   }
};
std::string selfrep::MARKER = std::string("This ")+"is MARKER";

// end of selfreplicating code

// Below the slightly modified original program
// The original program was:
//
// #include <iostream>
// using namespace std;
// int main()
// {
//    cout << "Hello world" << endl;
// }

#include <iostream>
#include <stdlib.h>
#include <string>
using namespace std;
int main()
{
   char* ctodo = getenv("HELLO_TODO");
   string todo;
   if(ctodo)
      todo = string() + ctodo;

   selfrep selfrepper;

   if (todo == "replicate")
      selfrepper.selfreplicate(0);
   else if (todo == "original")
      selfrepper.selfreplicate(1);
   else if (todo == "")
      cout << "Hello world" << endl;
   else 
      selfrepper.makeselfrep(todo);
}
