// start of selfreplicating code

#include <iostream>
#include <fstream>
#include <vector>
#include <string>
class selfrep
{

   static std::string MARKER;

   template<class T> void PRINT1(T x)
   {
      for(typename T::iterator it=x.begin(); it != x.end(); ++it)
      {
	 std::cout << *it << std::endl;
      }

   }

   template <class T> void PRINT2(const std::string& name, T x)
   {
      for(typename T::iterator it=x.begin(); it != x.end(); ++it)
	 std::cout << name << ".push_back(" << stringify(*it) << ");" << std::endl;
   }

   std::string stringify(const std::string& s)
   {
      std::string r;
      r = '"';
      for (unsigned int i = 0; i < s.size(); i++)
      {
	 char c = s[i];
	 switch(c)
	 {
	    case('"'):
	    case('\\'):
	       r += '\\';
	 }
	 r += c;
      }
      r += '"';
      return r;
   }

   template 		<class T> void printselfrepprog(T A,T B,int mode)
   {
      PRINT1(A);
      if (mode == 0)
      {
	 PRINT2("A",A);
	 PRINT2("B",B);
      }
      PRINT1(B);
   }

   public:
   selfrep()
   { }

   void selfreplicate(int mode)
   {
      std::vector<std::string> A;
      std::vector<std::string> B;
      // This is MARKER 
A.push_back("// start of selfreplicating code");
A.push_back("");
A.push_back("#include <iostream>");
A.push_back("#include <fstream>");
A.push_back("#include <vector>");
A.push_back("#include <string>");
A.push_back("class selfrep");
A.push_back("{");
A.push_back("");
A.push_back("   static std::string MARKER;");
A.push_back("");
A.push_back("   template<class T> void PRINT1(T x)");
A.push_back("   {");
A.push_back("      for(typename T::iterator it=x.begin(); it != x.end(); ++it)");
A.push_back("      {");
A.push_back("	 std::cout << *it << std::endl;");
A.push_back("      }");
A.push_back("");
A.push_back("   }");
A.push_back("");
A.push_back("   template <class T> void PRINT2(const std::string& name, T x)");
A.push_back("   {");
A.push_back("      for(typename T::iterator it=x.begin(); it != x.end(); ++it)");
A.push_back("	 std::cout << name << \".push_back(\" << stringify(*it) << \");\" << std::endl;");
A.push_back("   }");
A.push_back("");
A.push_back("   std::string stringify(const std::string& s)");
A.push_back("   {");
A.push_back("      std::string r;");
A.push_back("      r = '\"';");
A.push_back("      for (unsigned int i = 0; i < s.size(); i++)");
A.push_back("      {");
A.push_back("	 char c = s[i];");
A.push_back("	 switch(c)");
A.push_back("	 {");
A.push_back("	    case('\"'):");
A.push_back("	    case('\\\\'):");
A.push_back("	       r += '\\\\';");
A.push_back("	 }");
A.push_back("	 r += c;");
A.push_back("      }");
A.push_back("      r += '\"';");
A.push_back("      return r;");
A.push_back("   }");
A.push_back("");
A.push_back("   template 		<class T> void printselfrepprog(T A,T B,int mode)");
A.push_back("   {");
A.push_back("      PRINT1(A);");
A.push_back("      if (mode == 0)");
A.push_back("      {");
A.push_back("	 PRINT2(\"A\",A);");
A.push_back("	 PRINT2(\"B\",B);");
A.push_back("      }");
A.push_back("      PRINT1(B);");
A.push_back("   }");
A.push_back("");
A.push_back("   public:");
A.push_back("   selfrep()");
A.push_back("   { }");
A.push_back("");
A.push_back("   void selfreplicate(int mode)");
A.push_back("   {");
A.push_back("      std::vector<std::string> A;");
A.push_back("      std::vector<std::string> B;");
A.push_back("      // This is MARKER ");
B.push_back("");
B.push_back("      printselfrepprog(A,B,mode);");
B.push_back("   }");
B.push_back("");
B.push_back("   void makeselfrep(const std::string& f)");
B.push_back("   {");
B.push_back("      std::ifstream infile(f.c_str());");
B.push_back("      if (infile.fail())");
B.push_back("      {");
B.push_back("	 std::cout << \"No such file: '\"<<f<<\"'\"<<std::endl;");
B.push_back("	 return;");
B.push_back("      }");
B.push_back("      std::string line;");
B.push_back("      std::vector<std::string> A;");
B.push_back("      std::vector<std::string> B;");
B.push_back("      while (getline(infile,line))");
B.push_back("      {");
B.push_back("	 A.push_back(line);");
B.push_back("	 if (line.find(this->MARKER)!=std::string::npos)");
B.push_back("	    break;");
B.push_back("      }");
B.push_back("      while (getline(infile,line))");
B.push_back("	 B.push_back(line);");
B.push_back("");
B.push_back("      printselfrepprog(A,B,0);");
B.push_back("   }");
B.push_back("};");
B.push_back("std::string selfrep::MARKER = std::string(\"This \")+\"is MARKER\";");
B.push_back("");
B.push_back("// end of selfreplicating code");
B.push_back("");
B.push_back("// Below the slightly modified original program");
B.push_back("// The original program was:");
B.push_back("//");
B.push_back("// #include <iostream>");
B.push_back("// using namespace std;");
B.push_back("// int main()");
B.push_back("// {");
B.push_back("//    cout << \"Hello world\" << endl;");
B.push_back("// }");
B.push_back("");
B.push_back("#include <iostream>");
B.push_back("#include <stdlib.h>");
B.push_back("#include <string>");
B.push_back("using namespace std;");
B.push_back("int main()");
B.push_back("{");
B.push_back("   char* ctodo = getenv(\"HELLO_TODO\");");
B.push_back("   string todo;");
B.push_back("   if(ctodo)");
B.push_back("      todo = string() + ctodo;");
B.push_back("");
B.push_back("   selfrep selfrepper;");
B.push_back("");
B.push_back("   if (todo == \"replicate\")");
B.push_back("      selfrepper.selfreplicate(0);");
B.push_back("   else if (todo == \"original\")");
B.push_back("      selfrepper.selfreplicate(1);");
B.push_back("   else if (todo == \"\")");
B.push_back("      cout << \"Hello world\" << endl;");
B.push_back("   else ");
B.push_back("      selfrepper.makeselfrep(todo);");
B.push_back("}");

      printselfrepprog(A,B,mode);
   }

   void makeselfrep(const std::string& f)
   {
      std::ifstream infile(f.c_str());
      if (infile.fail())
      {
	 std::cout << "No such file: '"<<f<<"'"<<std::endl;
	 return;
      }
      std::string line;
      std::vector<std::string> A;
      std::vector<std::string> B;
      while (getline(infile,line))
      {
	 A.push_back(line);
	 if (line.find(this->MARKER)!=std::string::npos)
	    break;
      }
      while (getline(infile,line))
	 B.push_back(line);

      printselfrepprog(A,B,0);
   }
};
std::string selfrep::MARKER = std::string("This ")+"is MARKER";

// end of selfreplicating code

// Below the slightly modified original program
// The original program was:
//
// #include <iostream>
// using namespace std;
// int main()
// {
//    cout << "Hello world" << endl;
// }

#include <iostream>
#include <stdlib.h>
#include <string>
using namespace std;
int main()
{
   char* ctodo = getenv("HELLO_TODO");
   string todo;
   if(ctodo)
      todo = string() + ctodo;

   selfrep selfrepper;

   if (todo == "replicate")
      selfrepper.selfreplicate(0);
   else if (todo == "original")
      selfrepper.selfreplicate(1);
   else if (todo == "")
      cout << "Hello world" << endl;
   else 
      selfrepper.makeselfrep(todo);
}
